/*
Once diff or tie is drawn, demar line is fixed. or else issue. 
bug-->when diff is draw, Demar click has bug??
Scan through Array, merge conseq segment of line if there are in same direction
Auto recognisation of PMOS, NMOS etc...
Auto save the Array to a file, Auto read in the file
*/

import processing.pdf.*; //for pdf printing

int gridX=50, gridY=50, width=1200, height=800;
int timePrevClick, timeCurrentClick;
float percentLegion=0.2; //how much of height is for legion
//per squre is resnG, the drawing grid is offset by 0.5*resnG
float resnG=min(width/gridX,height/gridY);

float dXMin=0.5*resnG, dXMax=width-0.5*resnG, dYMin=percentLegion*height+0.5*resnG, dYMax=height-0.5*resnG;

float currentWidth=resnG;
float wContact=0.9*resnG;
float wVia1   =0.6*resnG;
float wDmar   =0.2*resnG;
float wM2     =0.2*resnG;
float wM1     =0.4*resnG;
float wPoly   =0.6*resnG;
float wPdiff   =0.9*resnG;
float wNdiff   =0.9*resnG;
float wTie    =0.1*resnG;

int   currentSegment;  
//when clikc line start (waiting to terminate), click line end, =1 segment ...
//for BACKSPACE tracking. W/o this, previous ending will become line start and wait to terminate.
//via/contact also counted as 1 segment.

boolean gridDrawBegin; //be4 the 1st click = false, when true, wating to terminate.
boolean recordPDF;
boolean clickDLine;    //for demarcation line

int   msgState; //type of message to display
int   keyState=0; //keypress type: 0 normal, 1 key label, 2 place label, 3 delete, 4 clear, 5 save, 6 data

color cGray=#7C6F72, cWhite=#EDEBEB,  cLightgray=#D8D8C7,   cBlack=#0A0202;
color cPoly=#098E0E, cM1=#1925A2, cM2=#D30D3B, cNwell=#F26F1D;
color cContact=#7C6F72, cVia1=#0A0A0A, cPdiff=#D125E5,  cNdiff=#25DDE5, cTie=cBlack;
color cHighlight=cBlack;

color currentLayer;
int   currentLAlign=1; //key TAB to switch. 0 nothing. 1 to 6.

float[] startPt   =new float[2];
float[] stopPt    =new float[2];
float[] snapPt    =new float[2];
float[] tempPt    =new float[2]; //temp* is for temperary storage. All are free to use.
float[] tempPt1   =new float[2];

float   tempX, tempY, tempMax, tempMin;
int     tempI;
char    tempC;
boolean tempB;
String  tempS;
 
String labelTyping=" ", labelSaved="VDD1234"; 
 
ArrayList<gLine> gLines; //array to record line/via/contact
gridDLine     dmarL;           //demarcatioin line object
remarksBox    rB;              //remark box, contains text message
gLines     gL;              //there is only 1 gL
legionBox     lB;              //legion box
drawBox       dB;              //drawing box

//PImage f;

class gridDLine { 
  //Demarcation line
  float xStart,yStartEnd,xEnd; float wL; color cL;
  gridDLine(float y) { 
    //tempPt=returnPt();
    xStart=0; yStartEnd=y; xEnd=width;  cL=cNwell; wL=wDmar;
  } 
  void replace() {
    yStartEnd=gL.returnGDline();
    wL=wDmar;
  }
  void update() { 
      stroke(cL);
      strokeWeight(wL);
      line(xStart, yStartEnd, xEnd, yStartEnd); 
  } 
}


class gLines { 
  ArrayList<gLine> gLines;  
  int iSelect=-1;//-1 not selection
  color cSelect=currentLayer;
  gLines() {  
    gLines = new ArrayList<gLine>();
  } 
  void saveData(){
  String[] data = new String[gLines.size()+1];//add 1 for dmarline
  gLine L;
  for (int i = 0; i < gL.size(); i++ ) {
    L=gLines.get(i);
    data[i] = L.xStart+","+L.yStart+","+L.xEnd+","+L.yEnd+","+L.cL+","+L.wL+","+L.tL+","+
              L.tText+","+L.tTextAlign+","+L.tO; //orientation save but not retrive when load
  }
  data[gL.size()]=str(dmarL.yStartEnd); //last one for dmar line
  saveStrings("data.txt",data);
  }
  void loadData(){
    String[] data = loadStrings( "data.txt");
    gLine L;
    flush();
    for (int i = 0; i < data.length-1; i++ ) {//less one, last one for dmar line
        String[] s = split(data[i], ",");
        gLines.add(new gLine(float(s[0]), float(s[1]),float(s[2]), float(s[3]),int(s[4]),float(s[5]),
        s[6].charAt(0),s[7],int(s[8])));//dont need .tO as orientation auto calculated by gLine
    }
    dmarL.yStartEnd=float(data[data.length-1]);//last one for dmar line

  }
  void add(gLine L) { 
    int s; int o; gLine LP;
    gLines.add(L);  currentSegment++;
    
  } 
  void update(){
    update(cPdiff);update(cNdiff);update(cTie);update(cPoly);update(cContact);update(cM1);update(cVia1);update(cM2);
  }  
  void update(color c){
    for (int i = gLines.size()-1; i >= 0; i--) {
    gLine L = gLines.get(i);
    if (L.cL==c){L.update();} //update only layer by layer
    }
  }

  void pop(){
    if (gLines.size()==0){gridDrawBegin=false;}  //not remove if it is already empty
    if (gLines.size()>0) {
      int m=gLines.size()-1;
      gLine L=gLines.get(m);
      startPt[0]=L.xStart; startPt[1]=L.yStart;
      gLines.remove(m);   
      currentSegment--;  //since a line segment is removed...
      //if there is a via/contact, also remove it. Don't leave a lone via.
      if (m>=1) { //if m=0, m-1 index out of range.
        L=gLines.get(m-1);
        if (gridDrawBegin==true) {currentLayer=L.cL;} //set curlayer to previous record layer
        if (L.tL=='c' || L.tL=='v' || L.tL=='t'){
           gLines.remove(m-1);currentSegment--;
           if (gLines.size()>0){
               L=gLines.get(m-2); 
               if (gridDrawBegin==true) {currentLayer=L.cL;} //set curlayer to previous record layer be4 via/contact
           }
        } 
      }
      if (currentSegment<=0) {gridDrawBegin=false;currentSegment=0;}
    }    
  }
  void flush(){
    gLines.clear();
    resetVar();
  }
  int size(){
    return gLines.size();
  }

  float returnGDline(){ //D line can land exactly on top of tie? how to solve?
    //scan through record, get ymin, ymax base on diff. Ensure placement of Demarcation line proper.
    float Ymin, Ymax, Yret;
    int imax;
    boolean tieCrash=false;
    tempPt=returnPt(); 
    Ymin=dYMin; Ymax=dYMax;
    for (int i = gLines.size()-1; i >=0 ; i--) {
      gLine L=gLines.get(i);
      //need to scan all diff, set max, min
      if (L.cL==cPdiff ){  Ymin=max(L.yStart,L.yEnd,Ymin);}  
      if (L.cL==cNdiff ){  Ymax=min(L.yStart,L.yEnd,Ymax);}                            
    }
    Ymin=Ymin+2*resnG;Ymax=Ymax-2*resnG; //allowance bet Dline to Pdiff/Ndiff
    //trying to find a y-coord witin constraint
    Yret=constrain(tempPt[1],Ymin,Ymax);
    imax=int(max(Ymax-Yret,Yret-Ymin)/resnG);
    //Alog to search for crash with Tie. Start with center, offset grid +-1, +-2.. Until a non-crash found 
    for (int j=0; j<=imax; j++){
      tempY=Yret+j*resnG; tieCrash=false;
      if (tempY>Ymin && tempY<Ymax){
          for (int i = gLines.size()-1; i >=0 ; i--) {
              gLine L=gLines.get(i);
              if (L.cL==cTie && tempY==L.yStart ){  tieCrash=true;break;} 
          }
          if (tieCrash==false){return tempY;} 
      }
      tempY=Yret-j*resnG; tieCrash=false;
      if (tempY>Ymin && tempY<Ymax){
          for (int i = gLines.size()-1; i >=0 ; i--) {
              gLine L=gLines.get(i);
              if (L.cL==cTie && tempY==L.yStart ){  tieCrash=true;break;} 
          }
          if (tieCrash==false){return tempY;}  
      }
    }      
    return Yret; //if come to here. The return value will crash with tie.
  }  
  boolean selectScan(float x,float y){
    boolean b=false; gLine L; 
    for (int i = gLines.size()-1; i >=0 ; i--) {
      L=gLines.get(i);
      b=withinLine(x,y,L.xStart,L.yStart,L.xEnd, L.yEnd); //check whether your click is within the line/pt
      //store the index (iSelect) and color (cSelect)
      if (b==true){iSelect=i;cSelect=L.cL;L.cL=cHighlight;gLines.set(i,L);msgState=10;return b;}
    }    
    return b;//return true to indicate a record is selected
  }
  
  float[] selectElement(){ //for key 'd' click to select record
    boolean sB=false;gLine L; 
    float[] sPt=new float[2]; 
    tempPt=returnPt(); 
    if (iSelect!=-1){ //if previously selected, now u click, chg the color of the record back to original cSelect).
      L=gLines.get(iSelect);L.cL=cSelect;gLines.set(iSelect,L);
    }
    //start selection process...
    iSelect=-1;msgState=9;
    //start from 1 center pt, keep checking for surrounding pt
    //or else, difficult to select LABEL
    //Once a valid record is select, code will break/return out
    sPt[0]=tempPt[0];sPt[1]=tempPt[1];
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}
    sPt[0]=tempPt[0]+resnG; sPt[1]=tempPt[1];
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;} 
    sPt[0]=tempPt[0]-resnG; sPt[1]=tempPt[1];
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}   
    sPt[0]=tempPt[0];       sPt[1]=tempPt[1]+resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;} 
    sPt[0]=tempPt[0];       sPt[1]=tempPt[1]-resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}  
    sPt[0]=tempPt[0]-resnG; sPt[1]=tempPt[1]-resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;} 
    sPt[0]=tempPt[0]+resnG; sPt[1]=tempPt[1]+resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}   
    sPt[0]=tempPt[0]+resnG; sPt[1]=tempPt[1]-resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}   
    sPt[0]=tempPt[0]-resnG; sPt[1]=tempPt[1]+resnG;
    sB=selectScan(sPt[0],sPt[1]); if (sB==true){return sPt;}      
    return sPt;
  }
  
  void deleteElement(){//for key 'd', once selected, can delete the record
       gLine L;
       if (iSelect!=-1 & gLines.isEmpty()==false){//if selected and records not empty
          L=gLines.get(iSelect);
          if (L.tL!='l'){gLines.remove(iSelect); } //if non-line, just delelte 1 record
          else{ //if line, must check left/right record
             if ((iSelect+1)<gL.size()){//if next record is via or contact remove.
                 L=gLines.get(iSelect+1);
                 if (L.tL=='c' || L.tL=='v' ){gLines.remove(iSelect+1);}
             }
             gLines.remove(iSelect);  //size reduce 1, index same
             if (iSelect-1>0){//if previos is via,contact,tie, also remove
                L=gLines.get(iSelect-1);
                if (L.tL=='c' || L.tL=='v' || L.tL=='t'){gLines.remove(iSelect-1);}
             } 
          }
       }
       iSelect=-1;  msgState=9;              
  }
  void trimRecord(){ 
      //duplicated lines, dot, t,v,c,a will be removed. Run once after register();
      //don't need to repeatedly run
      boolean b=false; gLine lR, lT;
      float[] rPt=new float[2]; 
      if (gLines.size()>=2){println("size record",gLines.size());
        for (int i = 0; i<gLines.size();  i++) {
            for (int j = i+1; j<gLines.size();  j++) {
                //once a recrod is merged/deleted, index is invalid, must breakout of this method
                //since trimRecord is backgroup op and non-critical, take ur time to trim...
                lR=gLines.get(i); lT=gLines.get(j);      
                if (lR.tL=='l' && lT.tL=='l' && lR.cL==lT.cL ){
                   if      ((lR.tO==0 || lR.tO==180) && lR.yStart==lT.yStart && (lR.tO==lT.tO || lR.tO==(lT.tO+180)%360)){
                      b=canMergeLine(lR.xStart,lR.xEnd,lT.xStart,lT.xEnd);
                      if (b==true){rPt=getMergePt(lR.xStart,lR.xEnd,lT.xStart,lT.xEnd);
                                   println("merge 0/180",i,j);
                                   mergeRecord(i,j,rPt[0],lR.yStart,rPt[1],lR.yEnd);break;
                      }
                   }
                   //for a dot, it is usually catpure as oritentation=0deg, so for vertical line, dot=0deg is not merged.
                   //isDot() is used for checking in order to merge Dot of 0deg with verticle (90/270)line.
                   else if ((lR.tO==90 || lR.tO==270) && lR.xStart==lT.xStart && (lR.tO==lT.tO || lR.tO==(lT.tO+180)%360 || isDot(lT))){ 
                      b=canMergeLine(lR.yStart,lR.yEnd,lT.yStart,lT.yEnd);
                      if (b==true){rPt=getMergePt(lR.yStart,lR.yEnd,lT.yStart,lT.yEnd);
                                   println("merge 90/270",i,j);
                                   mergeRecord(i,j,lR.xStart,rPt[0],lR.xEnd,rPt[1]);break;
                      }
                   }
                   else {   }
                }
                else if(lR.tL=='a' && lT.tL=='a'){
                   if (lR.xStart==lT.xStart && lR.yStart==lT.yStart){
                       mergeRecord(i,j,lR.xStart,lR.yStart,lR.xEnd,lR.yEnd);b=true;break; }
                }
                else if(lR.tL=='v' && lT.tL=='v'){
                   if (lR.xStart==lT.xStart && lR.yStart==lT.yStart){
                       mergeRecord(i,j,lR.xStart,lR.yStart,lR.xEnd,lR.yEnd);b=true;break; }
                }
                else if(lR.tL=='c' && lT.tL=='c'){
                   if (lR.xStart==lT.xStart && lR.yStart==lT.yStart){
                       mergeRecord(i,j,lR.xStart,lR.yStart,lR.xEnd,lR.yEnd);b=true;break; }
                }
                else if(lR.tL=='t' && lT.tL=='t'){
                   if (lR.xStart==lT.xStart && lR.yStart==lT.yStart){
                       mergeRecord(i,j,lR.xStart,lR.yStart,lR.xEnd,lR.yEnd);b=true;break; }
                }
                else {   }
            } 
            if (b==true){break;} //if true, break out of another for loop
        }
      }   
  }
  boolean isDot(gLine L){ //is record is a Dot, return true
      if(L.xStart==L.xEnd && L.yStart==L.yEnd){return true;}
      else {return false;}
  }
  boolean canMergeLine(float rStart,float rEnd,float tStart, float tEnd){ 
       //check if 2 line in same orientation, aligned can be merge
       //application for verticle or horizontal line.
       boolean b=true;float rMin, rMax,tMin,tMax;
       rMin=min(rStart,rEnd); rMax=max(rStart,rEnd);
       tMin=min(tStart,tEnd); tMax=max(tStart,tEnd);
       if (tMin>rMax || tMax<rMin){return false;}
       else {return true;}
  }  
  float[] getMergePt(float rStart,float rEnd,float tStart, float tEnd){ 
     //for 2 line: ref and target. The target will be deleted and ref's Start and End value is changed
     //to merge into 1 line.
     float[] rPt=new float[2]; 
     float pMin, pMax;
     pMin=min(min(rStart,rEnd),min(tStart,tEnd));
     pMax=max(max(rStart,rEnd),max(tStart,tEnd));
     if      (rStart==pMin){rEnd=pMax;}
     else if (rStart==pMax){rEnd=pMin;}
     else if (rEnd==pMin)  {rStart=pMax;}
     else if (rEnd==pMax)  {rStart=pMin;}
     else {}
     rPt[0]=rStart;rPt[1]=rEnd; return rPt;
  }
  
  void mergeRecord(int iR, int iT, float xStart,float yStart,float xEnd,float yEnd){
       //target record is removed. Ref record is update with name start/end pt.
       gLine lR;
       lR=gLines.get(iR); 
       lR.xStart=xStart;lR.yStart=yStart;lR.xEnd=xEnd;lR.yEnd=yEnd;
       gLines.remove(iT);
  }
  void procCMOS(){ //check crossing of poly with diffusion and signal a MOS
       boolean b=false; gLine lR, lT;
       float[] rPt=new float[2];   
       for (int i = 0; i<gLines.size();  i++) {
           for (int j = 0; j<gLines.size();  j++) {
                lR=gLines.get(i); lT=gLines.get(j);      
                if (lR.cL==cPoly && (lT.cL==cPdiff || lT.cL==cNdiff )){
                    drawIfCross(lR,lT);
                }
            }
       }               
  }
  void drawIfCross(gLine lR,gLine lT){
       //check orientation, then check crossing each other
       if     ((lR.tO==0 || lR.tO==180) && (lT.tO==90 || lT.tO==270) ){
           if ( (lR.yStart>min(lT.yStart,lT.yEnd) && lR.yStart<max(lT.yStart,lT.yEnd)) && (lT.xStart>min(lR.xStart,lR.xEnd) && lT.xStart<max(lR.xStart,lR.xEnd))){
               noFill();stroke(cBlack);strokeWeight(1);ellipse(lT.xStart,lR.yStart,resnG,resnG);
           }  
       }
       else if((lR.tO==90 || lR.tO==270) && (lT.tO==0 || lT.tO==180) ){
           //same as previous, now T/R flip over
           if ( (lT.yStart>min(lR.yStart,lR.yEnd) && lT.yStart<max(lR.yStart,lR.yEnd)) && (lR.xStart>min(lT.xStart,lT.xEnd) && lR.xStart<max(lT.xStart,lT.xEnd))){
               noFill();stroke(cBlack);strokeWeight(1);ellipse(lR.xStart,lT.yStart,resnG,resnG);
           }  

       }
       else {  }
  }

  
}
 
class gLine { //line object. Use for line, via, contact, tie
//tO orientation, tL type, 
  float xStart,yStart,xEnd,yEnd;
  float wL;  color cL;   char tL;  int tO;
  String tText;  int tTextAlign;
  gLine(float x1,float y1, float x2, float y2, color c,float w, char t, String s, int ta) {  
    xStart=x1; yStart=y1; xEnd=x2; yEnd=y2; cL=c; wL=w; tL=t;
    tO=returnOrient(xStart,yStart,xEnd,yEnd);
    tText=s; tTextAlign=ta;
  } 
  void update() { 
    stroke(cL);strokeWeight(wL);
    if (tL=='l' || tL=='c' || tL=='v'){ 
       line(xStart, yStart, xEnd, yEnd);
    }
    if (tL=='t'){ 
      //if tie, draw a cross (2 lines). tie= dot (info)+ cross (for show only)
      //if the dot is removed, the cross auto not display
      line(xStart-resnG, yStart-resnG, xStart+resnG, yStart+resnG);
      line(xStart-resnG, yStart+resnG, xStart+resnG, yStart-resnG);
    } 
    else if(tL=='a'){
      fill(cL); //color of text
      labelAlign(tTextAlign);
      text(tText,xStart,yStart);strokeWeight(1);ellipse(xStart,yStart,5, 5);
      textAlign(LEFT);strokeWeight(wL);
    }
    else{  } //{} will give error, make sure space bet {}
  }  
}

//add line/via/contact to array, increase currentSegment
//trimRecord is being run at the end.
void registerLine(char t){  //t can be l, c, v, t, a(label)
    
  if (t=='l'){
      stopPt=returnPt();
      snapPt=snapGrid(startPt[0], startPt[1], stopPt[0],stopPt[1]);
      gL.add(new gLine(startPt[0], startPt[1], snapPt[0], snapPt[1],currentLayer,currentWidth,t,"",0));
      startPt=snapPt;
  } 
  else if (t=='c'){
      gL.add(new gLine(startPt[0], startPt[1], startPt[0], startPt[1],cContact,wContact,t,"",0));
  }
  else if (t=='v'){
      gL.add(new gLine(startPt[0], startPt[1], startPt[0], startPt[1],cVia1,wVia1,t,"",0));
  }
  else if (t=='t'){ //tia
      gL.add(new gLine(startPt[0], startPt[1], startPt[0], startPt[1],cTie,wTie,t,"",0));
      currentSegment=1;  //tie always start with 1 segment
  }
  else if (t=='a'){ //label
      tempPt=returnPt();
      gL.add(new gLine(tempPt[0], tempPt[1], tempPt[0], tempPt[1],currentLayer,currentWidth,t,labelSaved,currentLAlign));
  }
  else { }//{} error
  gL.trimRecord();
}

//also handle label placement 
class remarksBox { //user instruction is here
  String[] sBox=new String[13];
  float x=3*resnG; 
  float y=8.5*resnG;
  remarksBox(){
      sBox[0]="Welcome to Stick Diagramme. Click to start drawing...";
      sBox[1]="Click to start drawing...";
      sBox[2]="ENTER to end drawing, Click to continuous drawing...";  
      sBox[3]="c to clear all. Enter to exit.";  
      sBox[4]="i for 'stick.png'. p for 'stick.pdf. ENTER to exit.";
      sBox[5]="";
      sBox[6]="Click for demarcation line...";
      sBox[7]="Key label (max 7char & press Enter) or b to place";  
      sBox[8]="Click=place label.TAB for align. 'a'=change label. Enter=exit.";
      sBox[9]="Click to select. ENTER to exit";
      sBox[10]="d to delete. ENTER to exit.";
      sBox[11]="s to save record to .txt. l to load. ENTER to exit.";
      sBox[12]="read/write file failure. ENTER to exit."; 
  }
  void update() {
      fill(currentLayer);    
      textSize(1*resnG); 
      text("'w' demarcation line,  'p' pdiff,  'n' ndiff,  '0' poly,  '1' metal1,  '2' metal 2,  "+
           "'UP' via up,  'DOWN' via down,  't' substract tie,  'a' label,  'b' place label,",x,4.5*resnG );
      text("'ESC' exit,  'c' clear all,  'backspace' clear,  'd' delete,  's' save png/pdf,  'f' data file",x,6*resnG );
      textSize(1.5*resnG); 
      text(sBox[msgState], x,y);
      if (keyState==1)     {text(labelTyping,62.5*resnG,8.5*resnG);}
      else if (keyState==2){
        labelAlign(currentLAlign);
        tempPt=returnPt();
        text(labelSaved,tempPt[0],tempPt[1]);
      }
      else { text(labelSaved,62.5*resnG,8.5*resnG); }
      textAlign(LEFT);//for the rest of text, is LEFT
  }
} 

void labelAlign(int m){
      switch(m) {
      case 1:  textAlign(LEFT); break;
      case 2:  textAlign(CENTER); break;
      case 3:  textAlign(RIGHT); break;
      case 4:  textAlign(CENTER,TOP);
      case 5:  textAlign(CENTER,CENTER);
      case 6:  textAlign(CENTER,BOTTOM);
      default:
      }
}

class legionBox {
  float w=2*resnG;
  legionBox(){
  }
  void update() {
    fill(cLightgray);
    strokeWeight(0);
    rect(0,0,width, percentLegion*height);
    fill(cPoly);  rect(3*resnG, 1*resnG, w, w);    text("poly",   5*resnG, 2.5*resnG);
    fill(cM1);    rect(10*resnG, 1*resnG, w, w);   text("metal1",12*resnG, 2.5*resnG);
    fill(cM2);    rect(20*resnG, 1*resnG, w, w);   text("metal2",22*resnG,2.5*resnG);
    fill(cNwell); rect(30*resnG, 1*resnG, w, w);   text("demar line",32*resnG,2.5*resnG);
    fill(cPdiff); rect(44*resnG, 1*resnG, w, w);   text("pdiff",46*resnG,2.5*resnG);
    fill(cNdiff); rect(53*resnG, 1*resnG, w, w);   text("ndiff",55*resnG,2.5*resnG);
    fill(cTie); stroke(cTie);strokeWeight(wTie);      text("subs tie",64*resnG,2.5*resnG);
    line(62*resnG, 1*resnG, 64*resnG, 3*resnG);
    line(64*resnG, 1*resnG, 62*resnG, 3*resnG); 
    noFill(); rect(62*resnG, 6.3*resnG, 6*w, 1.5*w);   
    fill(cBlack); text("label:",56*resnG,8.5*resnG);  

  }
} 



class drawBox {
  drawBox(){ }
  void update() {
    strokeWeight(1);
    fill(cWhite);
    rect(0,percentLegion*height-0.5*resnG,width, height);
    stroke(cLightgray); 
    tempX=0.5*resnG; tempY=percentLegion*height+0.5*resnG;
    while (tempX<=width){line(tempX,tempY,tempX,height-0.5*resnG);tempX=tempX+resnG;}
    tempX=0.5*resnG; tempY=tempX;
    while (tempY<=width){line(tempX,tempY,width-0.5*resnG,tempY);tempY=tempY+resnG;}
    //image(f, 0,percentLegion*height-0.5*resnG,width, height);
  }
} 



void setup() {
  size(width,height);  
  currentLayer=cPoly;
  resetVar();
  gL=   new gLines();
  dmarL=new gridDLine(height/2+0.5*resnG); 
  rB=new remarksBox();
  lB=new legionBox();
  dB=new drawBox();
  //f=loadImage("p.gif");

}

void draw() {
  frame.setTitle( " Stick Diagramme Editor by TST " );
  if (recordPDF==true){ beginRecord(PDF, "frame.pdf");     }
  dB.update();
  if (gridDrawBegin==true){  //if 1st click already done, waiting to terminate...
    msgState=2;
    tempPt=returnPt();  //get the point (constranted)
    snapPt=snapGrid(startPt[0], startPt[1], tempPt[0], tempPt[1]); //only verticle or horizontal line
    stroke(currentLayer);
    if        (currentLayer==cPdiff){currentWidth=wPdiff;}
    else if   (currentLayer==cNdiff){currentWidth=wNdiff;} 
    else if   (currentLayer==cPoly){currentWidth=wPoly;}
    else if   (currentLayer==cContact) {currentWidth=wContact;} 
    else if   (currentLayer==cM1)  {currentWidth=wM1;} 
    else if   (currentLayer==cVia1)  {currentWidth=wVia1;} 
    else if   (currentLayer==cM2)  {currentWidth=wM2;}
    else                          {currentWidth=0.1*resnG;}      
   
    strokeWeight(currentWidth);
    line(startPt[0], startPt[1], snapPt[0], snapPt[1]);
  }  
  lB.update();
  rB.update();
  dmarL.update(); 
  //gL.trimRecord();
  gL.update(); 
  gL.procCMOS();
  if (recordPDF==true){ recordPDF=false; endRecord();  }

}

//return snap pt, constrain to drawing area. Return 1 pt (x,y)
//for diff, constain by demarcation line
float[] returnPt(){  
  float[] temp = new float[2];
  temp[0]=constrain(returnGrid(mouseX),dXMin+1*resnG,dXMax-1*resnG); 
  if (currentLayer==cPdiff){
    temp[1]=constrain(returnGrid(mouseY),dYMin+1*resnG,dmarL.yStartEnd-2*resnG);}
  else if(currentLayer==cNdiff){
    temp[1]=constrain(returnGrid(mouseY),dmarL.yStartEnd+2*resnG,dYMax-1*resnG);}
  else if(currentLayer==cTie){
    if (returnGrid(mouseY)<=dmarL.yStartEnd){
        temp[1]=constrain(returnGrid(mouseY),dYMin+1*resnG,dmarL.yStartEnd-2*resnG);}
    else {
        temp[1]=constrain(returnGrid(mouseY),dmarL.yStartEnd+2*resnG,dYMax-1*resnG);}
  }   
  else{temp[1]=constrain(returnGrid(mouseY),dYMin,dYMax);
       temp[0]=constrain(returnGrid(mouseX),dXMin,dXMax); //x-axis constraint
  }
  return temp;
                  
} 

//snap to grid. Return 1 value
float returnGrid(float x){ 
  float temp;
  temp=x-(x%resnG)+0.5*resnG;
  return temp;
} 

//for orthogonlal. Return 1 pt (x,y). Used when clickDrawBegin=True
float[] snapGrid(float x1,float y1, float x2, float y2){ 
  float[] temp = new float[2];
  float dx, dy;
  dx = x2-x1; dy=y2-y1;
  temp[0]=x2; temp[1]=y2;
  if (abs(dy)<abs(dx)) {temp[1]=y1;}
  else       {temp[0]=x1;}
  return temp;
} 

//return orientation of line or dot, Dot = 0.
int returnOrient(float xStart, float yStart, float xEnd, float yEnd){
    int o=0; float dx=xEnd-xStart; float dy=yEnd-yStart;
    //tO is orientation. 0 (pt right),90 (pt north),180,270. Default for non-line=0
    if (dx==0)     {if (dy>0){o=270;}if (dy<0){o=90;}}
    else if (dy==0){if (dx>0){o=0;} if (dx<0){o=180;}}
    else           {o=0;}
    return o;
}

boolean withinLine(float x, float y, float xStart, float yStart, float xEnd, float yEnd){
    boolean b=false;
    tempX=xEnd-xStart; tempY=yEnd-yStart;
    if      (tempY==0 && y==yStart){
        if      (xEnd>=xStart){ {if (x>=xStart && x<=xEnd){b= true;} }}
        else if (xEnd<xStart) { {if (x<=xStart && x>=xEnd){b= true;} }}
    }
    else if (tempX==0 && x==xStart){
        if      (yEnd>=yStart){ {if (y>=yStart && y<=yEnd){b= true;} }}
        else if (yEnd<yStart) { {if (y<=yStart && y>=yEnd){b= true;} }}
    }
    else {  }
    return b;
}

void keyPressed() {
    if (keyState==0){
        if (keyCode == ENTER && gridDrawBegin==true ) {terminateLine(1,currentLayer);} 
        if (keyCode==UP && gridDrawBegin==true){
          registerLine('l');
          msgState=2;
          if      (currentLayer==cPdiff || currentLayer==cNdiff)  {registerLine('c');currentLayer=cM1;}
          else if (currentLayer==cPoly)   {registerLine('c');currentLayer=cM1;}
          else if (currentLayer==cM1){registerLine('v');currentLayer=cM2;}
          else { }
    
        }
        if (keyCode==DOWN && gridDrawBegin==true){
          registerLine('l');
          msgState=2;
          if (currentLayer==cM2)     {registerLine('v');currentLayer=cM1;}
          else if (currentLayer==cM1){registerLine('c');currentLayer=cPoly;}
          else { }
        }
        //BACKSPACE key
        if (keyCode == 8 ) {
          gL.pop(); 
        }   
  
        switch(key) {
        case 'c': //'cl' to clear all
          terminateLine(3,currentLayer); keyState=4; break;
        case '0': 
          terminateLine(1,cPoly);break; 
        case '1': 
          terminateLine(1,cM1);   break;
        case '2': 
          terminateLine(1,cM2);   break;
        case 'p': 
          terminateLine(1,cPdiff);   break;
        case 'n': 
          terminateLine(1,cNdiff);   break;
        case 't': 
          terminateLine(1,cTie); break;
          //if (gridDrawBegin==true){registerLine('l');}
          //currentLayer=tie;   msgState=1;gridDrawBegin=false;  currentSegment=0;break; 
          //once t, start with 1st click. Previous segment is not terminated but aborted.
          //tie can only be click and immediately go to m1 for drawing
        case 's':
          keyState=5; terminateLine(4,currentLayer) ; break;
        case 'w': //demarcation line, set clickDLine, so that next click will set Dmarline
          clickDLine=true; terminateLine(6,cNwell); break;
        case 'a': //label editor mode;
          keyState=1; terminateLine(7,currentLayer);break;
        case 'b': //place label;
          keyState=2; terminateLine(8,currentLayer); break;
        case 'd': //select&delete;
          keyState=3; terminateLine(9,currentLayer); break;
        case 'f': //load/save data from/to file
          keyState=6; terminateLine(11,currentLayer);break;
        case 'z': //temp
          break;
        default:
          msgState=1; keyState=0;
        }
    }
    else if (keyState==1){ //label related
          msgState=7; 
          if (key == CODED && key!='\n' && key!=TAB) { } 
          else if (key == '\n' || key =='b') {
              if (labelTyping.length()>=8){labelSaved=labelTyping.substring(0,8);}
              else                        {labelSaved=labelTyping;}
              labelTyping = "" ; 
              resetVar();
              if (key=='b'){keyState=2;msgState=8;}
              // Otherwise, concatenate the String
          } 
          else if(labelTyping.length()<8){ labelTyping = labelTyping + key; }
          else { }
    }
    else if (keyState==2){
         if (key==TAB){
              currentLAlign++;
              if (currentLAlign>=7){currentLAlign=1;}
         }           
         else if (key =='\n'){resetVar();}//end label placement.
         else if (key=='a'){keyState=1;msgState=7;}
         else {   }
    }
    else if (keyState==3){
     if (key=='d'){gL.deleteElement();resetVar();}
     if (key =='\n'){resetVar();}//end.
    }
    else if (keyState==4){
     if (key == 'c'){resetVar();gL.flush(); }  
     if (key =='\n'){resetVar();}
    } 
    else if (keyState==5){
      if (key== 'i'){saveFrame("stick.png");resetVar();} 
      if (key=='p') {recordPDF=true; resetVar();} 
      if (key =='\n'){resetVar();} 
    }  
    else if (keyState==6){ //file save/load
      if (key== 's'){gL.saveData();resetVar();} 
      if (key=='l') {gL.loadData(); resetVar();} 
      if (key =='\n'){resetVar();} 
    }
    else { }
}
     


void mousePressed() {
  if (keyState==0){
      timeCurrentClick=millis();
      //if double-click, perform like 'ENTER' key and return.
      if ((timeCurrentClick-timePrevClick)<400 && gridDrawBegin==true) {
        terminateLine(1,currentLayer); return;
      }
      if (clickDLine==true ) { dmarL.replace(); msgState=1;  clickDLine=false; currentLayer=cPoly;}   
      else if (gridDrawBegin == false) {
          startPt=returnPt();  currentSegment=0; gridDrawBegin=true;   
          //if tie,immediately go up to m1
          if (currentLayer==cTie) { registerLine('t'); currentLayer=cM1; 
          }
      }
      else{ registerLine('l'); }
      timePrevClick=millis();
  }
  else if (keyState==2){
      if (labelSaved.length()!=0){
        registerLine('a');
      }
  }
  else if (keyState==3){
      gL.selectElement();
  }
  else { }
}

void resetVar(){
  msgState=0; currentSegment=0; gridDrawBegin=false;
  clickDLine=false;  timePrevClick=millis(); recordPDF=false; keyState=0;
}


void terminateLine(int mS,color cL){ //move to new msg, new layer
    if (gridDrawBegin==true){registerLine('l');}
    gridDrawBegin=false;
    currentLayer=cL;   msgState=mS;currentSegment=0;
}

